/*####COPYRIGHTBEGIN####
 -------------------------------------------
 Copyright (C) 2005 Wapice Ltd

 Author: Kåre Särs (kare.sars@wapice.com)

 This program is free software; you can redistribute it and/or
 modify it under the terms of the GNU General Public License
 as published by the Free Software Foundation; either version 2
 of the License, or (at your option) any later version.

 This program is distributed in the hope that it will be useful,
 but WITHOUT ANY WARRANTY; without even the implied warranty of
 MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 GNU General Public License for more details.

 You should have received a copy of the GNU General Public License
 along with this program; if not, write to:
 The Free Software Foundation, Inc.
 59 Temple Place - Suite 330
 Boston, MA  02111-1307
 USA.

 As a special exception, if other files instantiate templates or
 use macros or inline functions from this file, or you compile
 this file and link it with other works to produce a work based
 on this file, this file does not by itself cause the resulting
 work to be covered by the GNU General Public License. However
 the source code for this file must still be made available in
 accordance with section (3) of the GNU General Public License.

 This exception does not invalidate any other reasons why a work
 based on this file might be covered by the GNU General Public
 License.
 -------------------------------------------
####COPYRIGHTEND####*/


#ifndef BACNET_SEND_APDU_H
#define BACNET_SEND_APDU_H



BACnet_npdu_t *apdu_simple_ack(BACnet_npdu_t *npdu, INT8U invoke_id, INT8U service);
BACnet_npdu_t *apdu_error(BACnet_npdu_t *npdu, INT8U invoke_id, INT8U err_choice, INT8U class, INT8U code);
BACnet_npdu_t *apdu_abort(BACnet_npdu_t *npdu, INT8U invoke_id, INT8U reason);
BACnet_npdu_t *apdu_reject(BACnet_npdu_t *npdu, INT8U invoke_id, INT8U reason);

BACnet_npdu_t *apdu_iam(BACnet_npdu_t *npdu);
BACnet_npdu_t *apdu_ihave(BACnet_npdu_t *npdu, BACnet_object_t *object);


BACnet_npdu_t *apdu_read_property(BACnet_npdu_t *npdu, INT8U InvokeId,
                                  INT16U object_type, INT32U instance,
                                  BOOLEAN sa, INT8U max_segs, INT8U max_seg_size,
                                  INT8U property, INT8U *array);
BACnet_npdu_t *apdu_read_property_ack(BACnet_npdu_t *npdu, INT8U invoke_id, BACnet_object_t *object,
                                      INT32U property, INT32U array_index);

BACnet_npdu_t *apdu_who_is(BACnet_npdu_t *npdu);
BACnet_npdu_t *apdu_who_is_ranged(BACnet_npdu_t *npdu, INT32U instance_low, INT32U instance_hi);

BACnet_npdu_t *apdu_who_has(BACnet_npdu_t *npdu, INT16U object_type, INT32U instance, INT8U *name);
BACnet_npdu_t *apdu_who_has_ranged(BACnet_npdu_t *npdu, INT32U instance_low, INT32U instance_hi,
                                   INT16U object_type, INT32U instance, INT8U *name);


BACnet_npdu_t *apdu_write_prop_real(BACnet_npdu_t *npdu, INT8U InvokeId,
                                    INT16U object_type, INT32U instance, INT8U property,
                                    REAL *value, INT8U *array, INT8U *priority);

BACnet_npdu_t *apdu_write_prop_enum(BACnet_npdu_t *npdu, INT8U InvokeId,
                                    INT16U object_type, INT32U instance, INT8U property,
                                    INT8U *value, INT8U *array, INT8U *priority);

BACnet_npdu_t *segmented_c_ack_pdu(BACnet_npdu_t *npdu, INT8U invoke_id, INT8U *data, INT16U data_len,
                                   INT16U segment_size, INT8U sequence_number, INT8U proposedWS);

BACnet_npdu_t *segment_ack_pdu(BACnet_npdu_t *npdu, INT8U invoke_id, INT8U sequence_number,
                               INT8U actualWS, BOOLEAN nak, BOOLEAN srv);
#endif
