/*####COPYRIGHTBEGIN####
 -------------------------------------------
 Copyright (C) 2005 Wapice Ltd

 Author: Kåre Särs (kare.sars@wapice.com)

 This program is free software; you can redistribute it and/or
 modify it under the terms of the GNU General Public License
 as published by the Free Software Foundation; either version 2
 of the License, or (at your option) any later version.

 This program is distributed in the hope that it will be useful,
 but WITHOUT ANY WARRANTY; without even the implied warranty of
 MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 GNU General Public License for more details.

 You should have received a copy of the GNU General Public License
 along with this program; if not, write to:
 The Free Software Foundation, Inc.
 59 Temple Place - Suite 330
 Boston, MA  02111-1307
 USA.

 As a special exception, if other files instantiate templates or
 use macros or inline functions from this file, or you compile
 this file and link it with other works to produce a work based
 on this file, this file does not by itself cause the resulting
 work to be covered by the GNU General Public License. However
 the source code for this file must still be made available in
 accordance with section (3) of the GNU General Public License.

 This exception does not invalidate any other reasons why a work
 based on this file might be covered by the GNU General Public
 License.
 -------------------------------------------
####COPYRIGHTEND####*/


/* THIS IS JUST A BAD EXAMPLE OF A MAIN FILE AND */
/* NOT A RECOMENDED IMPLEMENTATION */

#include <stdio.h>  /* printf */
#include <string.h>  /* memset */
#include <stdlib.h> /* atoi */
#include <unistd.h> /* usleep */
#include <semaphore.h>  /* sem_t */
#include <pthread.h>
#include <sched.h> /* sched_setscheduler */
#include <linux/rtc.h> /* rtc */
#include <fcntl.h> /* open */
#include <sys/ioctl.h> /* ioctl */


#include "platform.h"
#include "conf.h"
#include "npdu.h"
#include "apdu.h"
#include "mstp.h"
#include "rs485.h"
#include "bacenum.h"
#include "object.h"
#include "make_apdu.h"
#include "bacdcode.h"

/**********************************************************************/
/* Global Variables */
struct mstp_port_struct_t mstpPort;
pthread_mutex_t isr_mutex= PTHREAD_MUTEX_INITIALIZER;

/* we use static memory allocation for the devices */
BACnet_device_t     device[1];
BACnet_analog_val_t a_values[4];
BACnet_binary_val_t b_values[4];
BACnet_object_t     Objects[9];
BACnet_object_list  ObjectList;


INT8U dev_name[] = "BACnet Device";
INT8U active_str[]="Active";
INT8U passive_str[]="Passive";
INT8U on_str[]="On";
INT8U off_str[]="Off";

INT8U VendorName[]="Wapice Ltd";
INT8U ModelName[]="ModelName";
INT8U FirmwareRev[]="FirmwareRev";
INT8U ApplSoftwareRev[]="ApplSoftwareRev";

int mac, brt_i=3;
int pr=1;

const INT16U BaudRateTable[4] =
{
    9600,
    9600,
    19200,
    38400
};

BOOLEAN realy_is_solemaster=TRUE;

/**********************************************************************/
/* Function s start here */
/**********************************************************************/

/**********************************************************************/
void *timer_thr(void *var) {
    static struct timeval tv_new, tv_old;
    int delay;
//    int rtc_fd, ret;
//    unsigned long data, tmp;
    //
    //     /* open rtc device */
//     rtc_fd = open ("/dev/rtc", O_RDONLY);
//     if (rtc_fd <= 0) {
//         perror("/dev/rtc");
//     }
    //
    //     /* Turn on update interrupts*/
    //     /* try to set 1024 Hz on interrupts */
//     ret = ioctl(rtc_fd, RTC_IRQP_SET, 1024);
//     if (ret == -1) {
//         perror("ioctl");
//     }
    //
//     ret = ioctl(rtc_fd, RTC_IRQP_READ, &tmp);
//     if (ret == -1) {
//         perror("ioctl");
//     }
//     printf("the interrupt interval is %ld Hz\n", tmp);
    //
    //     /* enable interrupts */
//     ret = ioctl(rtc_fd, RTC_PIE_ON, 0);
//     if (ret == -1) {
//         perror("ioctl");
//     }

    gettimeofday(&tv_new, NULL);

    while (1) {

        //ret = read(rtc_fd, &data, sizeof(unsigned long));
        //ret = read(rtc_fd, &data, sizeof(unsigned long));
        usleep(2000);

        /* take a new timestamp */
        tv_old=tv_new;
        gettimeofday(&tv_new, NULL);
        delay = ((tv_diff(tv_old,tv_new)+500)/1000);
        /*printf("locked  timer\n");*/
        /* add the timestamp differences to the timers */
        if (delay > 5 ) printf("delay in timer thread = %d ms\n", delay);

        MSTP_Millisecond_Timer(delay);
        APPL_Millisecond_Timer(delay);
    }
    return NULL;
}

/**********************************************************************/
void *network_thr(void *var) {
    INT16U len, err;
    INT8U from_mac;
    INT16U type;
    BACnet_npdu_t orig_npdu;
    BACnet_npdu_t *pdu;
    BACnet_address *dest;
    INT16U i;
    BOOLEAN SendIAm=FALSE;


    while (1) {
        init_npdu(&orig_npdu);
        pdu = &orig_npdu;

        len=MSTP_read(pdu->data, MAX_NPDU_SIZE, &from_mac, &type);
        /*
        two_p_printf("Read MSG Len = %d Type = %04x\nMsg: ", len, type);
        for (i=0; i<len; i++)
        {
        one_p_printf("%02x ",pdu->data[i]);
    }
        no_p_printf("\n");
        */
        if (type & READ_ERR_MISSED_FRAME)
        {
            printf("Missed read!\n");
            type &= ~READ_ERR_MISSED_FRAME;
        }
        if (type & READ_RESTART_PFM)
        {
            SendIAm = TRUE;
            type &= ~READ_RESTART_PFM;
        }
        switch (type)
        {
            case READ_TRY_NEXT_BR:
                try_next_baudrate();
                break;

            case READ_ERR_REPL_TMO:
                printf("Response Time Out\n");
                break;

            case FRAME_TYPE_REPLY_POSTPONED:
                printf("Response Postponed\n");
                break;

            case FRAME_TYPE_TEST_REQUEST:
                no_p_printf("Test Request:");
                for (i=0; i<len; i++)
                {
                    one_p_printf("%02x ",pdu->data[i]);
                }
                no_p_printf("\n");
                len=MSTP_write(pdu->data, len, from_mac, MSTP_SEND_TEST_RESPONSE);
                if (len>=512) {print_t(); printf("write error 0x%x\n", len);}
                break;

            case FRAME_TYPE_TEST_RESPONSE:
                if (len > MAX_NPDU_SIZE) {printf("Len too big\n"); break;}
                no_p_printf("Test Responce:");
                for (i=0; i<len; i++)
                {
                    one_p_printf("%02x ",pdu->data[i]);
                }
                no_p_printf("\n");
                break;

            case FRAME_TYPE_BACNET_DATA_EXPECTING_REPLY:
            case FRAME_TYPE_BACNET_DATA_NOT_EXPECTING_REPLY:
                if (len > MAX_NPDU_SIZE) {printf("Len too big\n"); break;}
                if (len == 0) {printf("Len = 0\n"); break;}

                err = parse_npdu(pdu->data, len, pdu);
                if (err == NPDU_MSG_NETWORK_MSG) {
                    /* Network message (Ignore) */
                    no_p_printf("Network message (Ignore)\n");
                }
                else if (err !=0) printf("NPDU Error: %d\n", err);
                else {

                    two_p_printf("Message from MAC:%d len=%d ",from_mac, pdu->data_len);
                    no_p_printf("APDU=0x");
                    for (i=0; i<pdu->data_len; i++) {
                        one_p_printf("%02x ", pdu->data[i]);
                    }
                    no_p_printf("\n");

                    /* save the source address for the destination of the reply */
                    if (npdu_has_src(pdu->control)) dest=&pdu->src;
                    else                            dest=NULL;

                    if (npdu_has_dest(pdu->control) && (pdu->dest.net != 0xFFFF)) {
                        /* 6.5.2.1 */
                        print_t(); printf("DNET present and != 0xFFFF  => disgard\n");
                    }
                    else {
                        pdu = parse_apdu(pdu);

                        if (pdu!=NULL)
                        {
                    //sleep(1);
                            no_p_printf("sending: 0x");
                            for (len=0; len<=pdu->data_len-1; len++) one_p_printf("%02x ", pdu->data[len]);
                            no_p_printf("\n\n");
                        }

                        if (pdu == NULL) {
                            if (type == FRAME_TYPE_BACNET_DATA_EXPECTING_REPLY) {
                                print_t(); printf("expected: a reply from parse_apdu!\n");
                                /* do something for the problem */
                            }
                        }
                        else {
                            /* Should it be Broadcast */
                            if (pdu->broadcast!=NOT_BROADCAST) {
                                from_mac=0xFF;
                                if (pdu->broadcast==GLOBAL_BROADCAST) {
                                    pdu->dest.net=0xFFFF;
                                    pdu->dest.len=0;
                                    dest = &pdu->dest;
                                }
                            }
                            /* add NPDU header */
                            add_npdu_header(pdu, dest, NULL, FALSE, PRIORITY_NORMAL);

                            /* send the reply */
                            /*printf("waiting for write\n"); */
                            len=MSTP_write(pdu->data, pdu->data_len, from_mac,
                                           (type == FRAME_TYPE_BACNET_DATA_EXPECTING_REPLY) ? MSTP_SEND_REPLY : MSTP_SEND_NO_WAIT);
                            /*printf("Wrote\n");*/
                            if (len>=512) { print_t();printf("Write error %d\n", len);}
                        }
                    }
                }
                break;

            case 0:
                /* nothing to se here */
                break;

            default:
                printf("Undefined Frame Type :%d\n", type);
                break;
        }
        if (SendIAm == TRUE) {
            print_t(); printf("sending \"I am\"\n");

            init_npdu(&orig_npdu);
            pdu = &orig_npdu;
            /* make Iam apdu */
            pdu=apdu_iam(pdu);
            /* broadcast the I am */
            from_mac=0xFF;
            pdu->dest.net=0xFFFF;
            pdu->dest.len=0;
            dest = &pdu->dest;
            /* add NPDU header */
            len = add_npdu_header(pdu, dest, NULL, FALSE, PRIORITY_NORMAL);

            /* send the message */
            len=MSTP_write(pdu->data, pdu->data_len, from_mac, MSTP_SEND_NO_WAIT);
            if (len>=512) {print_t(); printf("write error 0x%x\n", len);}
            SendIAm = FALSE;
        }


    }
    return NULL;
}


/**********************************************************************/
void indicate_sole_master(BOOLEAN soleMaster)
{
    static BOOLEAN old_state=TRUE;

    if (soleMaster != old_state)
    {
        print_t();
        printf((soleMaster == TRUE) ? "I am sole master\n" : "I'm no longer sole master\n");
    }
    old_state=soleMaster;

    if (mstp_port->SoleMaster != realy_is_solemaster)
    {
        print_t();
        printf((mstp_port->SoleMaster == TRUE) ? "R: I am sole master\n" : "R: I'm no longer sole master\n");
    }
    realy_is_solemaster=mstp_port->SoleMaster;
}

/**********************************************************************/
void try_next_baudrate(void)
{
    RS485_Stop_Uart();
    MSTP_Re_Init(mac);

    brt_i--; if (brt_i==0) brt_i=3;
    printf("MAC=%3d, Baudrate=%d\n", mac, BaudRateTable[brt_i]);
    RS485_Init_Uart(BaudRateTable[brt_i]);

    return;
}
/* return the number off added objects on failure we do not reash NUM_OBJECTS */
/* (Sorry I know it is not wery clean) */
/**********************************************************************/
void init_objects(void)
{
    ObjectList.node=Objects;
    ObjectList.NumDeviceObjects=1;
    ObjectList.Size=1;
    /* clear the binary and analog values. They are later calculated */
    ObjectList.FirstBinaryValue=0;
    ObjectList.NumBinaryValues=0;
    ObjectList.FirstAnalogValue=0;
    ObjectList.NumAnalogValues=0;

    /* Add the Device */
    ObjectList.node[0].obj_type = OBJECT_DEVICE;
    ObjectList.node[0].instance = 1234567;
    ObjectList.node[0].name = dev_name;

    /* fill the structure */
    device[0].SystemStatus = STATUS_OPERATIONAL;
    device[0].VendorName = VendorName;
    device[0].VendorId = 160;
    device[0].ModelName = ModelName;
    device[0].FirmwareRev = FirmwareRev;
    device[0].ApplSoftwareRev = ApplSoftwareRev;

    memset(device[0].ServicesSupported, 0, BACNET_SERV_SUPP_BSTR_LEN);
    set_bit_in_string(device[0].ServicesSupported, asReadProperty, TRUE);
    set_bit_in_string(device[0].ServicesSupported, asWriteProperty, TRUE);
    set_bit_in_string(device[0].ServicesSupported, asDeviceCommunicationControl, TRUE);
    set_bit_in_string(device[0].ServicesSupported, asReinitializeDevice, TRUE);
    set_bit_in_string(device[0].ServicesSupported, asI_Am, TRUE);
    set_bit_in_string(device[0].ServicesSupported, asI_Have, TRUE);
    set_bit_in_string(device[0].ServicesSupported, asWho_Has, TRUE);
    set_bit_in_string(device[0].ServicesSupported, asWho_Is, TRUE);

    memset(device[0].ObjectsSupported, 0, BACNET_OBJ_SUPP_BSTR_LEN);
    set_bit_in_string(device[0].ObjectsSupported, OBJECT_ANALOG_VALUE, TRUE);
    set_bit_in_string(device[0].ObjectsSupported, OBJECT_BINARY_VALUE, TRUE);
    set_bit_in_string(device[0].ObjectsSupported, OBJECT_DEVICE, TRUE);
    ObjectList.node[0].type.dev = &device[0];


    /*printf("adding analog values\n");*/
    /* add analog values */
    init_analog_value(&a_values[0], (INT8U*)"Analog Val 0", 9600.0, UNITS_HERTZ, RWC_READ_ONLY);
    init_analog_value(&a_values[1], (INT8U*)"Analog Val 1", 0.61, UNITS_CYCLES_PER_HOUR, RWC_READ_WRITE);
    init_analog_value(&a_values[2], (INT8U*)"Analog Val 2", 1000, UNITS_METERS, RWC_COMMANDABLE);
    init_analog_value(&a_values[3], (INT8U*)"Analog Val 3", 1000, UNITS_METERS, RWC_COMMANDABLE);

    /*printf("adding binary values\n");*/
    /* add binary values */
    init_binary_value(&b_values[0], (INT8U*)"Binary Val 0", TRUE, passive_str, active_str, RWC_READ_ONLY);
    init_binary_value(&b_values[1], (INT8U*)"Binary Val 1", FALSE, off_str, on_str, RWC_READ_WRITE);
    init_binary_value(&b_values[2], (INT8U*)"Binary Val 2", TRUE, off_str, on_str, RWC_COMMANDABLE);
    init_binary_value(&b_values[3], (INT8U*)"Binary Val 3", TRUE, off_str, on_str, RWC_COMMANDABLE);

}


/**********************************************************************/
int read_device_dbr(INT8U mac, INT32U inst)
{
    BACnet_npdu_t npdu_orig;
    BACnet_npdu_t *npdu;
    INT16U err;

    /* PROP_DATABASE_REVISION */
    //sleep(1);
    //printf("\n-->PROP_DATABASE_REVISION\n");
    init_npdu(&npdu_orig);
    npdu = &npdu_orig;
    npdu = apdu_read_property(npdu, 21, OBJECT_DEVICE, inst, FALSE, 0, 0, PROP_DATABASE_REVISION, NULL);
    add_npdu_header(npdu, NULL, NULL, TRUE, PRIORITY_NORMAL);
    err=MSTP_write(npdu->data, npdu->data_len, mac, MSTP_SEND_AND_WAIT);
    if (err>=512) printf("PROP_DATABASE_REVISION\n");

    return 0;
}


/**********************************************************************/
int read_device_ol(INT8U mac, INT32U inst)
{
    BACnet_npdu_t npdu_orig;
    BACnet_npdu_t *npdu;
    INT16U err;

    /* PROP_OBJECT_LIST */
    //sleep(1);
    //printf("\n-->PROP_OBJECT_LIST\n");
    init_npdu(&npdu_orig);
    npdu = &npdu_orig;
    npdu = apdu_read_property(npdu, 13, OBJECT_DEVICE, inst, FALSE, 0, 0, PROP_OBJECT_LIST, NULL);
    add_npdu_header(npdu, NULL, NULL, TRUE, PRIORITY_NORMAL);
    err=MSTP_write(npdu->data, npdu->data_len, mac, MSTP_SEND_AND_WAIT);
    if (err>=512) printf("PROP_OBJECT_LIST\n");

    return 0;
}

/**********************************************************************/
int read_device(INT8U mac, INT32U inst)
{
    BACnet_npdu_t npdu_orig;
    BACnet_npdu_t *npdu;
    INT16U err;
    REAL tmp=2.4;
    /*static INT8U w_val=30;*/
    INT8U priority=16;

    no_p_printf("Start Read Device:\n");
    /* Name */
    //printf("\n-->Name\n");
    init_npdu(&npdu_orig);
    npdu = &npdu_orig;
    npdu = apdu_read_property(npdu, 1, OBJECT_DEVICE, inst, FALSE, 0, 0, PROP_OBJECT_NAME, NULL);
    add_npdu_header(npdu, NULL, NULL, TRUE, PRIORITY_NORMAL);
    err=MSTP_write(npdu->data, npdu->data_len, mac, MSTP_SEND_AND_WAIT);
    if (err>=512) printf("Name\n");

    //sleep(1);
    /* Type */
    //printf("\n-->Type\n");
    init_npdu(&npdu_orig);
    npdu = &npdu_orig;
    npdu = apdu_read_property(npdu, 2, OBJECT_DEVICE, inst, FALSE, 0, 0, PROP_OBJECT_TYPE, NULL);
    add_npdu_header(npdu, NULL, NULL, TRUE, PRIORITY_NORMAL);
    err=MSTP_write(npdu->data, npdu->data_len, mac, MSTP_SEND_AND_WAIT);
    if (err>=512) printf("Type\n");

    //sleep(1);

    /* Status */
    //printf("\n-->Status\n");
    init_npdu(&npdu_orig);
    npdu = &npdu_orig;
    npdu = apdu_read_property(npdu, 3, OBJECT_DEVICE, inst, FALSE, 0, 0, PROP_SYSTEM_STATUS, NULL);
    add_npdu_header(npdu, NULL, NULL, TRUE, PRIORITY_NORMAL);
    err=MSTP_write(npdu->data, npdu->data_len, mac, MSTP_SEND_AND_WAIT);
    if (err>=512) printf("Status\n");

    //sleep(1);
    /* PROP_VENDOR_NAME */
    //printf("\n-->PROP_VENDOR_NAME\n");
    init_npdu(&npdu_orig);
    npdu = &npdu_orig;
    npdu = apdu_read_property(npdu, 4, OBJECT_DEVICE, inst, FALSE, 0, 0, PROP_VENDOR_NAME, NULL);
    add_npdu_header(npdu, NULL, NULL, TRUE, PRIORITY_NORMAL);
    err=MSTP_write(npdu->data, npdu->data_len, mac, MSTP_SEND_AND_WAIT);
    if (err>=512) printf("PROP_VENDOR_NAME\n");

    //sleep(1);
    /* PROP_VENDOR_IDENTIFIER */
    //printf("\n-->PROP_VENDOR_IDENTIFIER\n");
    init_npdu(&npdu_orig);
    npdu = &npdu_orig;
    npdu = apdu_read_property(npdu, 5, OBJECT_DEVICE, inst, FALSE, 0, 0, PROP_VENDOR_IDENTIFIER, NULL);
    add_npdu_header(npdu, NULL, NULL, TRUE, PRIORITY_NORMAL);
    err=MSTP_write(npdu->data, npdu->data_len, mac, MSTP_SEND_AND_WAIT);
    if (err>=512) printf("PROP_VENDOR_IDENTIFIER\n");

    //sleep(1);
    /* PROP_MODEL_NAME */
    //printf("\n-->PROP_MODEL_NAME\n");
    init_npdu(&npdu_orig);
    npdu = &npdu_orig;
    npdu = apdu_read_property(npdu, 6, OBJECT_DEVICE, inst, FALSE, 0, 0, PROP_MODEL_NAME, NULL);
    add_npdu_header(npdu, NULL, NULL, TRUE, PRIORITY_NORMAL);
    err=MSTP_write(npdu->data, npdu->data_len, mac, MSTP_SEND_AND_WAIT);
    if (err>=512) printf("PROP_MODEL_NAME\n");

    //sleep(1);
    /* PROP_FIRMWARE_REVISION */
    //printf("\n-->PROP_FIRMWARE_REVISION\n");
    init_npdu(&npdu_orig);
    npdu = &npdu_orig;
    npdu = apdu_read_property(npdu, 7, OBJECT_DEVICE, inst, FALSE, 0, 0, PROP_FIRMWARE_REVISION, NULL);
    add_npdu_header(npdu, NULL, NULL, TRUE, PRIORITY_NORMAL);
    err=MSTP_write(npdu->data, npdu->data_len, mac, MSTP_SEND_AND_WAIT);
    if (err>=512) printf("PROP_FIRMWARE_REVISION\n");

    //sleep(1);
    /* PROP_APPLICATION_SOFTWARE_VERSION */
    //printf("\n-->PROP_APPLICATION_SOFTWARE_VERSION\n");
    init_npdu(&npdu_orig);
    npdu = &npdu_orig;
    npdu = apdu_read_property(npdu, 8, OBJECT_DEVICE, inst, FALSE, 0, 0, PROP_APPLICATION_SOFTWARE_VERSION, NULL);
    add_npdu_header(npdu, NULL, NULL, TRUE, PRIORITY_NORMAL);
    err=MSTP_write(npdu->data, npdu->data_len, mac, MSTP_SEND_AND_WAIT);
    if (err>=512) printf("PROP_APPLICATION_SOFTWARE_VERSION\n");

    //sleep(1);
    /* PROP_PROTOCOL_VERSION */
    //printf("\n-->PROP_PROTOCOL_VERSION\n");
    init_npdu(&npdu_orig);
    npdu = &npdu_orig;
    npdu = apdu_read_property(npdu, 9, OBJECT_DEVICE, inst, FALSE, 0, 0, PROP_PROTOCOL_VERSION, NULL);
    add_npdu_header(npdu, NULL, NULL, TRUE, PRIORITY_NORMAL);
    err=MSTP_write(npdu->data, npdu->data_len, mac, MSTP_SEND_AND_WAIT);
    if (err>=512) printf("PROP_PROTOCOL_VERSION\n");

    //sleep(1);
    /* PROP_PROTOCOL_REVISION */
    //printf("\n-->PROP_PROTOCOL_REVISION\n");
    init_npdu(&npdu_orig);
    npdu = &npdu_orig;
    npdu = apdu_read_property(npdu, 10, OBJECT_DEVICE, inst, FALSE, 0, 0, PROP_PROTOCOL_REVISION, NULL);
    add_npdu_header(npdu, NULL, NULL, TRUE, PRIORITY_NORMAL);
    err=MSTP_write(npdu->data, npdu->data_len, mac, MSTP_SEND_AND_WAIT);
    if (err>=512) printf("PROP_PROTOCOL_REVISION\n");

    //sleep(1);
    /* PROP_PROTOCOL_SERVICES_SUPPORTED */
    //printf("\n-->PROP_PROTOCOL_SERVICES_SUPPORTED\n");
    init_npdu(&npdu_orig);
    npdu = &npdu_orig;
    npdu = apdu_read_property(npdu, 11, OBJECT_DEVICE, inst, FALSE, 0, 0, PROP_PROTOCOL_SERVICES_SUPPORTED, NULL);
    add_npdu_header(npdu, NULL, NULL, TRUE, PRIORITY_NORMAL);
    err=MSTP_write(npdu->data, npdu->data_len, mac, MSTP_SEND_AND_WAIT);
    if (err>=512) printf("PROP_PROTOCOL_SERVICES_SUPPORTED\n");

    //sleep(1);
    /* PROP_PROTOCOL_OBJECT_TYPES_SUPPORTED */
    //printf("\n-->PROP_PROTOCOL_OBJECT_TYPES_SUPPORTED\n");
    init_npdu(&npdu_orig);
    npdu = &npdu_orig;
    npdu = apdu_read_property(npdu, 12, OBJECT_DEVICE, inst, FALSE, 0, 0, PROP_PROTOCOL_OBJECT_TYPES_SUPPORTED, NULL);
    add_npdu_header(npdu, NULL, NULL, TRUE, PRIORITY_NORMAL);
    err=MSTP_write(npdu->data, npdu->data_len, mac, MSTP_SEND_AND_WAIT);
    if (err>=512) printf("PROP_PROTOCOL_OBJECT_TYPES_SUPPORTED\n");

    /* PROP_OBJECT_LIST */
    //sleep(1);
    //printf("\n-->PROP_OBJECT_LIST\n");
    init_npdu(&npdu_orig);
    npdu = &npdu_orig;
    npdu = apdu_read_property(npdu, 13, OBJECT_DEVICE, inst, FALSE, 0, 0, PROP_OBJECT_LIST, NULL);
    add_npdu_header(npdu, NULL, NULL, TRUE, PRIORITY_NORMAL);
    err=MSTP_write(npdu->data, npdu->data_len, mac, MSTP_SEND_AND_WAIT);
    if (err>=512) printf("PROP_OBJECT_LIST\n");

    /* PROP_MAX_APDU_LENGTH_ACCEPTED */
    //sleep(1);
    //printf("\n-->PROP_MAX_APDU_LENGTH_ACCEPTED\n");
    init_npdu(&npdu_orig);
    npdu = &npdu_orig;
    npdu = apdu_read_property(npdu, 14, OBJECT_DEVICE, inst, FALSE, 0, 0, PROP_MAX_APDU_LENGTH_ACCEPTED, NULL);
    add_npdu_header(npdu, NULL, NULL, TRUE, PRIORITY_NORMAL);
    err=MSTP_write(npdu->data, npdu->data_len, mac, MSTP_SEND_AND_WAIT);
    if (err>=512) printf("PROP_MAX_APDU_LENGTH_ACCEPTED\n");

    /* PROP_SEGMENTATION_SUPPORTED */
    //sleep(1);
    //printf("\n-->PROP_SEGMENTATION_SUPPORTED\n");
    init_npdu(&npdu_orig);
    npdu = &npdu_orig;
    npdu = apdu_read_property(npdu, 15, OBJECT_DEVICE, inst, FALSE, 0, 0, PROP_SEGMENTATION_SUPPORTED, NULL);
    add_npdu_header(npdu, NULL, NULL, TRUE, PRIORITY_NORMAL);
    err=MSTP_write(npdu->data, npdu->data_len, mac, MSTP_SEND_AND_WAIT);
    if (err>=512) printf("PROP_SEGMENTATION_SUPPORTED\n");

    /* PROP_APDU_TIMEOUT */
    //sleep(1);
    //printf("\n-->PROP_APDU_TIMEOUT\n");
    init_npdu(&npdu_orig);
    npdu = &npdu_orig;
    npdu = apdu_read_property(npdu, 16, OBJECT_DEVICE, inst, FALSE, 0, 0, PROP_APDU_TIMEOUT, NULL);
    add_npdu_header(npdu, NULL, NULL, TRUE, PRIORITY_NORMAL);
    err=MSTP_write(npdu->data, npdu->data_len, mac, MSTP_SEND_AND_WAIT);
    if (err>=512) printf("PROP_APDU_TIMEOUT\n");

    /* PROP_NUMBER_OF_APDU_RETRIES */
    //sleep(1);
    //printf("\n-->PROP_NUMBER_OF_APDU_RETRIES\n");
    init_npdu(&npdu_orig);
    npdu = &npdu_orig;
    npdu = apdu_read_property(npdu, 17, OBJECT_DEVICE, inst, FALSE, 0, 0, PROP_NUMBER_OF_APDU_RETRIES, NULL);
    add_npdu_header(npdu, NULL, NULL, TRUE, PRIORITY_NORMAL);
    err=MSTP_write(npdu->data, npdu->data_len, mac, MSTP_SEND_AND_WAIT);
    if (err>=512) printf("PROP_NUMBER_OF_APDU_RETRIES\n");

    /* PROP_MAX_MASTER */
    //sleep(1);
    //printf("\n-->PROP_MAX_MASTER\n");
    init_npdu(&npdu_orig);
    npdu = &npdu_orig;
    npdu = apdu_read_property(npdu, 18, OBJECT_DEVICE, inst, FALSE, 0, 0, PROP_MAX_MASTER, NULL);
    add_npdu_header(npdu, NULL, NULL, TRUE, PRIORITY_NORMAL);
    err=MSTP_write(npdu->data, npdu->data_len, mac, MSTP_SEND_AND_WAIT);
    if (err>=512) printf("PROP_MAX_MASTER\n");

    /* PROP_MAX_INFO_FRAMES */
    //sleep(1);
    //printf("\n-->PROP_MAX_INFO_FRAMES\n");
    init_npdu(&npdu_orig);
    npdu = &npdu_orig;
    npdu = apdu_read_property(npdu, 19, OBJECT_DEVICE, inst, FALSE, 0, 0, PROP_MAX_INFO_FRAMES, NULL);
    add_npdu_header(npdu, NULL, NULL, TRUE, PRIORITY_NORMAL);
    err=MSTP_write(npdu->data, npdu->data_len, mac, MSTP_SEND_AND_WAIT);
    if (err>=512) printf("PROP_MAX_INFO_FRAMES\n");

    /* PROP_DEVICE_ADDRESS_BINDING */
    //sleep(1);
    //printf("\n-->PROP_DEVICE_ADDRESS_BINDING\n");
    init_npdu(&npdu_orig);
    npdu = &npdu_orig;
    npdu = apdu_read_property(npdu, 20, OBJECT_DEVICE, inst, FALSE, 0, 0, PROP_DEVICE_ADDRESS_BINDING, NULL);
    add_npdu_header(npdu, NULL, NULL, TRUE, PRIORITY_NORMAL);
    err=MSTP_write(npdu->data, npdu->data_len, mac, MSTP_SEND_AND_WAIT);
    if (err>=512) printf("PROP_DEVICE_ADDRESS_BINDING\n");

    /* PROP_DATABASE_REVISION */
    //sleep(1);
    //printf("\n-->PROP_DATABASE_REVISION\n");
    init_npdu(&npdu_orig);
    npdu = &npdu_orig;
    npdu = apdu_read_property(npdu, 21, OBJECT_DEVICE, inst, FALSE, 0, 0, PROP_DATABASE_REVISION, NULL);
    add_npdu_header(npdu, NULL, NULL, TRUE, PRIORITY_NORMAL);
    err=MSTP_write(npdu->data, npdu->data_len, mac, MSTP_SEND_AND_WAIT);
    if (err>=512) printf("PROP_DATABASE_REVISION\n");



    init_npdu(&npdu_orig);
    npdu = &npdu_orig;
    npdu = apdu_read_property(npdu, 22, OBJECT_BINARY_VALUE, 15, FALSE, 0, 0, PROP_PRESENT_VALUE, NULL);
    add_npdu_header(npdu, NULL, NULL, TRUE, PRIORITY_NORMAL);
    err=MSTP_write(npdu->data, npdu->data_len, mac, MSTP_SEND_AND_WAIT);
    if (err>=512) printf("Write error %d\n", err);



    init_npdu(&npdu_orig);
    npdu = &npdu_orig;
    npdu = apdu_read_property(npdu, 23, OBJECT_ANALOG_VALUE, 23, FALSE, 0, 0, PROP_PRESENT_VALUE, NULL);
    add_npdu_header(npdu, NULL, NULL, TRUE, PRIORITY_NORMAL);
    err=MSTP_write(npdu->data, npdu->data_len, mac, MSTP_SEND_AND_WAIT);
    if (err>=512) printf("Write error %d\n", err);

    init_npdu(&npdu_orig);
    npdu = &npdu_orig;
    npdu = apdu_read_property(npdu, 24, OBJECT_ANALOG_VALUE, 24, FALSE, 0, 0, PROP_MINIMUM_OFF_TIME, NULL);
    add_npdu_header(npdu, NULL, NULL, TRUE, PRIORITY_NORMAL);
    err=MSTP_write(npdu->data, npdu->data_len, mac, MSTP_SEND_AND_WAIT);
    if (err>=512) printf("Write error %d\n", err);


    init_npdu(&npdu_orig);
    npdu = &npdu_orig;
    npdu = apdu_write_prop_real(npdu, 25, OBJECT_ANALOG_VALUE, 24, PROP_MINIMUM_OFF_TIME, &tmp, NULL, &priority);
    add_npdu_header(npdu, NULL, NULL, TRUE, PRIORITY_NORMAL);
    err=MSTP_write(npdu->data, npdu->data_len, mac, MSTP_SEND_AND_WAIT);
    if (err>=512) printf("Write error %d\n", err);

    init_npdu(&npdu_orig);
    npdu = &npdu_orig;
    npdu = apdu_write_prop_real(npdu, 26, OBJECT_ANALOG_VALUE, 24, PROP_OBJECT_NAME, &tmp, NULL, &priority);
    add_npdu_header(npdu, NULL, NULL, TRUE, PRIORITY_NORMAL);
    err=MSTP_write(npdu->data, npdu->data_len, mac, MSTP_SEND_AND_WAIT);
    if (err>=512) printf("Write error %d\n", err);

    init_npdu(&npdu_orig);
    npdu = &npdu_orig;
    npdu = apdu_write_prop_real(npdu, 27, OBJECT_ANALOG_VALUE, 24, PROP_OBJECT_NAME, &tmp, NULL, &priority);
    add_npdu_header(npdu, NULL, NULL, TRUE, PRIORITY_NORMAL);
    err=MSTP_write(npdu->data, npdu->data_len, mac, MSTP_SEND_AND_WAIT);
    if (err>=512) printf("Write error %d\n", err);

    return 0;
}

/********* -> BROKEN APDU!! *****************************************************/
BACnet_npdu_t *apdu_read_property_1(BACnet_npdu_t *npdu, INT8U InvokeId,
                                  INT16U object_type, INT32U instance,
                                  BOOLEAN sa, INT8U max_segs, INT8U max_seg_size,
                                  INT8U property, INT8U *array)
{
    if (npdu==NULL) return NULL;

    /* clear the old npdu data */
    init_npdu_data(npdu);

    npdu->data[0] = APDU_TYPE_CONFIRMED_REQUEST;
    if (sa == TRUE) {
        npdu->data[0] |= APDU_SEG_ACC;
        if ((max_segs > 7) || (max_seg_size > 15)) return NULL;
        npdu->data[1] = (max_segs << 4) | max_seg_size;
    }
    else {
        npdu->data[1] = 0; /* no segmentation accepted */
    }
    npdu->data[2] = InvokeId;
    /* no segmentation => no seq_num or prop_win_size */
    npdu->data[3] = SERVICE_CONFIRMED_READ_PROPERTY;
    npdu->data_len=4;

    npdu->data_len += encode_context_object_id(&npdu->data[npdu->data_len], 0, object_type, instance);
    npdu->data_len += encode_context_unsigned(&npdu->data[npdu->data_len], 1, property);
    npdu->data_len--;

    if (array != NULL) {
        npdu->data_len += encode_context_unsigned(&npdu->data[npdu->data_len], 2, *array);
    }

    return npdu;
}

/********* -> BROKEN APDU!! *****************************************************/
BACnet_npdu_t *apdu_read_property_2(BACnet_npdu_t *npdu, INT8U InvokeId,
                                    INT16U object_type, INT32U instance,
                                    BOOLEAN sa, INT8U max_segs, INT8U max_seg_size,
                                    INT8U property, INT8U *array)
{
    if (npdu==NULL) return NULL;

    /* clear the old npdu data */
    init_npdu_data(npdu);

    npdu->data[0] = APDU_TYPE_CONFIRMED_REQUEST;
    if (sa == TRUE) {
        npdu->data[0] |= APDU_SEG_ACC;
        if ((max_segs > 7) || (max_seg_size > 15)) return NULL;
        npdu->data[1] = (max_segs << 4) | max_seg_size;
    }
    else {
        npdu->data[1] = 0; /* no segmentation accepted */
    }
    npdu->data[2] = InvokeId;
    /* no segmentation => no seq_num or prop_win_size */
    npdu->data[3] = SERVICE_CONFIRMED_READ_PROPERTY;
    npdu->data_len=4;

    npdu->data_len += encode_context_object_id(&npdu->data[npdu->data_len], 0, object_type, instance);

    if (array != NULL) {
        npdu->data_len += encode_context_unsigned(&npdu->data[npdu->data_len], 2, *array);
    }

    return npdu;
}


/**********************************************************************/
int main(int argc, char *argv[]) {
    BACnet_npdu_t npdu_orig;
    BACnet_npdu_t *npdu;
    pthread_t thread;
    int dest;
    int err, inst;
    INT8S buffer[81], *ptr, *ptr2;
    INT8U priority=16;
    int stdin_fno=0;
    fd_set perm,set;
    struct timeval tv;
    struct sched_param p_pri;

    p_pri.sched_priority = 99;

    if (sched_setscheduler( 0, SCHED_RR, &p_pri) != 0) {
        printf("setting priority failed\n");
    }

    stdin_fno=fileno(stdin);
    FD_ZERO(&perm);
    FD_SET(stdin_fno,&perm);

    if (argc > 3) {
        printf("usage: mstp <MAC address> [/dev/ttyS..]\n");
        return -1;
    }

    if (argc < 2) {
        printf("usage: mstp <MAC address> [/dev/ttyS..]\n");
        return -1;
    }
    mac=atoi(argv[1]);
    if ((mac<0)|| (mac>MSTP_MAX_MASTER)) {
        printf("MAC address must be >=0, <=%d\n",MSTP_MAX_MASTER);
        return -1;
    }

    if (argc==3) strcpy(rs485_device, argv[2]);

    init_objects();

    MSTP_Init(&mstpPort, mac);
    RS485_Init_Uart(BaudRateTable[brt_i]);

    init_appl_layer();

    pthread_create(&thread, NULL, network_thr, NULL);
    mstp_port->run_msec_timer=FALSE;
    pthread_create(&thread, NULL, timer_thr, NULL);
    pthread_create(&thread, NULL, RS485_Send_Next_Byte, NULL);
    pthread_create(&thread, NULL, RS485_Interrupt_Handler, NULL);
    mstp_port->run_msec_timer=TRUE;

    for (;;) {

        /* read stdin for commands */
        fgets(buffer, 80, stdin);

        /* set values for select */
        tv.tv_sec=0;
        tv.tv_usec=0;
        set = perm;

        init_npdu(&npdu_orig);
        npdu = &npdu_orig;

        if ((buffer[0]=='s') || (buffer[0]=='S'))
        {
            do{
                npdu = apdu_who_is(npdu);
                //printf("npdu->data_len=%d\n", npdu->data_len);
                add_npdu_header(npdu, NULL, NULL, FALSE, PRIORITY_NORMAL);
                //printf("npdu->data_len=%d\n", npdu->data_len);

                err=MSTP_write(npdu->data, npdu->data_len, 0xff, MSTP_SEND_NO_WAIT);
                //printf("after who is\n");
                if (err>=512) printf("Write error %d\n", err);
                tv.tv_sec=0;
                tv.tv_usec=0;
                set = perm;
                fflush(stdout);
                if (select(FD_SETSIZE,&set,NULL,NULL,&tv) !=0 ) break;
                usleep(10000);
            } while (buffer[0]=='S');
        }
        else if (buffer[0]=='i')
        {
            inst = atoi(&buffer[1]);
            npdu = apdu_who_has(npdu, OBJECT_ANALOG_INPUT, inst, NULL);
            add_npdu_header(npdu, NULL, NULL, FALSE, PRIORITY_NORMAL);

            err=MSTP_write(npdu->data, npdu->data_len, 0xff, MSTP_SEND_NO_WAIT);
            //printf("after who has\n");
            if (err>=512) printf("Write error %d\n", err);
        }
        else if (buffer[0]=='v')
        {
            inst = atoi(&buffer[1]);
            npdu = apdu_who_has(npdu, OBJECT_ANALOG_VALUE, inst, NULL);
            add_npdu_header(npdu, NULL, NULL, FALSE, PRIORITY_NORMAL);

            err=MSTP_write(npdu->data, npdu->data_len, 0xff, MSTP_SEND_NO_WAIT);
            //printf("after who has\n");
            if (err>=512) printf("Write error %d\n", err);
        }
        else if (buffer[0]=='n')
        {
            dest = strtol(&buffer[1], &ptr, 0);
            if (ptr!=NULL) inst = atoi(ptr);
            else           inst = 1;
            npdu = apdu_read_property(npdu, 1, OBJECT_DEVICE, inst, FALSE, 0, 0, PROP_OBJECT_NAME, NULL);
            add_npdu_header(npdu, NULL, NULL, TRUE, PRIORITY_NORMAL);
            err=MSTP_write(npdu->data, npdu->data_len, dest, MSTP_SEND_AND_WAIT);
            //printf("after who has\n");
            if (err>=512) printf("Write error %d\n", err);
        }
        else if (buffer[0]=='N')
        {
            dest = strtol(&buffer[1], &ptr, 0);
            if (ptr!=NULL) inst = atoi(ptr);
            else           inst = 1;
            npdu = apdu_read_property_1(npdu, 1, OBJECT_DEVICE, inst, FALSE, 0, 0, PROP_OBJECT_NAME, NULL);
            add_npdu_header(npdu, NULL, NULL, TRUE, PRIORITY_NORMAL);
            err=MSTP_write(npdu->data, npdu->data_len, dest, MSTP_SEND_AND_WAIT);
            //printf("after who has\n");
            if (err>=512) printf("Write error %d\n", err);
        }
        else if (buffer[0]=='m')
        {
            dest = strtol(&buffer[1], &ptr, 0);
            if (ptr!=NULL) inst = atoi(ptr);
            else           inst = 1;
            npdu = apdu_read_property_2(npdu, 1, OBJECT_DEVICE, inst, FALSE, 0, 0, PROP_OBJECT_NAME, NULL);
            add_npdu_header(npdu, NULL, NULL, TRUE, PRIORITY_NORMAL);
            err=MSTP_write(npdu->data, npdu->data_len, dest, MSTP_SEND_AND_WAIT);
            //printf("after who has\n");
            if (err>=512) printf("Write error %d\n", err);
        }
        else if ((buffer[0]=='d') || (buffer[0]=='D'))
        {
            dest = strtol(&buffer[1], &ptr, 0);
            if (ptr!=NULL) inst = atoi(ptr);
            else           inst = 1;

            do {
                read_device(dest, inst);
                /* if we read anything from stdin, exit loop */
                tv.tv_sec=0;
                tv.tv_usec=3000;
                set = perm;
                fflush(stdout);
                if (select(FD_SETSIZE,&set,NULL,NULL,&tv) !=0 ) break;

            } while (buffer[0]=='D');
        }
        /* READ priority array */
        else if (buffer[0]=='P')
        {
            INT16U o_type;

            o_type = ((buffer[1]=='a') || (buffer[1]=='A')) ? OBJECT_ANALOG_VALUE : OBJECT_BINARY_VALUE;

            dest = strtol(&buffer[2], &ptr, 0);
            if (ptr!=NULL) inst = atoi(ptr);
            else           inst = 0;

            npdu = apdu_read_property(npdu, 1, o_type, inst, FALSE, 0, 0, PROP_PRIORITY_ARRAY, NULL);

            add_npdu_header(npdu, NULL, NULL, TRUE, PRIORITY_NORMAL);

            err=MSTP_write(npdu->data, npdu->data_len, dest, MSTP_SEND_AND_WAIT);
            if (err>=512) printf("Write error %d\n", err);
        }
        /* READ from object */
        else if ((buffer[0]=='r') || (buffer[0]=='R'))
        {
            INT16U o_type;
            BOOLEAN seg_acc;

            o_type = ((buffer[1]=='a') || (buffer[1]=='A')) ? OBJECT_ANALOG_VALUE : OBJECT_BINARY_VALUE;
            seg_acc = (buffer[0]=='R') ? TRUE : FALSE;

            dest = strtol(&buffer[2], &ptr, 0);
            if (ptr!=NULL) inst = atoi(ptr);
            else           inst = 0;

            npdu = apdu_read_property(npdu, 1, o_type, inst, seg_acc, 0, 0, PROP_PRESENT_VALUE, NULL);

            add_npdu_header(npdu, NULL, NULL, TRUE, PRIORITY_NORMAL);

            o_type=0;
            do {
                o_type++;
                if (realy_is_solemaster == FALSE)
                {
                    err=MSTP_write(npdu->data, npdu->data_len, dest, MSTP_SEND_AND_WAIT);
                }
                else
                {
                    printf("stopping sending for 20 seconds\n");
                    sleep(5);
                    printf("Continuing sending\n");
                    err = 0;
                }
                //printf("after read prop analog\n");
                if (err>=512) printf("Write error %d\n", err);

                /* if we read anything from stdin, exit loop */
                tv.tv_sec=0;
                tv.tv_usec=0;
                if ((o_type%10) == 0) {
                    /* if we get a request while writing we get confused so after */
                    /* 10 writes wait for any errors to clear and then continue. */
                    o_type=0;
                    tv.tv_usec=300000;
                }
                set = perm;
                fflush(stdout);
                if (select(FD_SETSIZE,&set,NULL,NULL,&tv) !=0 ) break;

            } while (buffer[1]=='A');
        }

        /* WRITE to object */
        else if ((buffer[0]=='w') || (buffer[0]=='W'))
        {
            INT16U o_type;
            REAL val;
            INT8U e_val;

            if (buffer[1]=='a') {
                o_type= OBJECT_ANALOG_VALUE;
            }
            else {
                o_type= OBJECT_BINARY_VALUE;
            }

            dest = strtol(&buffer[2], &ptr, 0);
            if (ptr!=NULL) {
                inst = strtol(&buffer[ptr-buffer], &ptr, 0);
                if (ptr!=NULL) {
                    val = (float)strtod(ptr, &ptr2);
                }
                else ptr2 = ptr;
            }
            else {
                inst = 0;
                val=0.0;
            }

            if (buffer[1]=='a') {
                if (ptr2 != ptr){
                    one_p_printf("analog val =%f\n", (float)val);
                }
                else {
                    no_p_printf("analog val =NULL\n");
                }
                npdu = apdu_write_prop_real(npdu, 0xab, OBJECT_ANALOG_VALUE, inst, PROP_PRESENT_VALUE, (ptr2!=ptr)?(REAL*)&val:NULL, NULL, &priority);
            }
            else {
                if (val>0) val=1;
                if (ptr2 != ptr) {
                    one_p_printf("binary val =%d\n", (INT8U)val);
                }
                else {
                    no_p_printf("binary val =NULL\n");
                }
                e_val = (INT8U)val;
                npdu = apdu_write_prop_enum(npdu, 0xab, OBJECT_BINARY_VALUE, inst, PROP_PRESENT_VALUE, (ptr2!=ptr)?&e_val:NULL, NULL, &priority);
            }
            add_npdu_header(npdu, NULL, NULL, TRUE, PRIORITY_NORMAL);

            o_type=0;
            do {
                o_type++;

                if (realy_is_solemaster == FALSE)
                {
                    err=MSTP_write(npdu->data, npdu->data_len, dest, MSTP_SEND_AND_WAIT);
                    //printf("after read prop analog\n");
                    if (err>=512) printf("Write error %d\n", err);
                }
                else
                {
                    printf("stopping sending for 20 seconds\n");
                    sleep(20);
                    printf("Continuing sending\n");
                    err = 0;
                }

                /* if we read anything from stdin, exit loop */
                tv.tv_sec=0;
                tv.tv_usec=0;
                if ((o_type%10) == 0) {
                    /* if we get a request while writing we get confused so after */
                    /* 10 writes wait for any errors to clear and then continue. */
                    o_type=0;
                    tv.tv_usec=300000;
                }
                set = perm;
                fflush(stdout);
                if (select(FD_SETSIZE,&set,NULL,NULL,&tv) !=0 ) break;

            } while (buffer[0]=='W');
        }

        else if (buffer[0]=='b')
        {
            try_next_baudrate();
        }
        else if (buffer[0]=='p')
        {
            pr ^= 1;
        }
        else if (buffer[0]=='t')
        {
            dest = atoi(&buffer[1]);
            err=MSTP_write((INT8U*)buffer, 15, dest, MSTP_SEND_TEST_REQUEST);
        }
    }
    return 0;
}

