/*####COPYRIGHTBEGIN####
 -------------------------------------------
 Copyright (C) 2005 Wapice Ltd

 Author: Kåre Särs (kare.sars@wapice.com)

 This program is free software; you can redistribute it and/or
 modify it under the terms of the GNU General Public License
 as published by the Free Software Foundation; either version 2
 of the License, or (at your option) any later version.

 This program is distributed in the hope that it will be useful,
 but WITHOUT ANY WARRANTY; without even the implied warranty of
 MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 GNU General Public License for more details.

 You should have received a copy of the GNU General Public License
 along with this program; if not, write to:
 The Free Software Foundation, Inc.
 59 Temple Place - Suite 330
 Boston, MA  02111-1307
 USA.

 As a special exception, if other files instantiate templates or
 use macros or inline functions from this file, or you compile
 this file and link it with other works to produce a work based
 on this file, this file does not by itself cause the resulting
 work to be covered by the GNU General Public License. However
 the source code for this file must still be made available in
 accordance with section (3) of the GNU General Public License.

 This exception does not invalidate any other reasons why a work
 based on this file might be covered by the GNU General Public
 License.
-------------------------------------------
####COPYRIGHTEND####*/

#include <stdio.h>
#include <stdlib.h>
#include <sys/select.h>
#include<sys/socket.h>
#include<netinet/in.h>
#include <sys/ioctl.h>
#include <unistd.h>
#include <string.h>
#include <fcntl.h> /* O_NDELAY... */
#include <termios.h>
#include <sys/time.h>


/*************************************************************
* Returns the timedifference of two timestamps in usecs
*************************************************************/
int tv_diff(struct timeval tv1,struct timeval tv2) {
    long ds,dus;

    ds=(tv2.tv_sec&0x0000ffff)-(tv1.tv_sec&0x0000ffff);
    dus=(tv2.tv_usec)-(tv1.tv_usec);
    dus+=ds*1000000;

    return (int)dus;
}


/**************************************************************************/
int main(int argc, char *argv[]) {
    int tty_sock, ret, i, br=38400;
    char dev[256]="/dev/ttyS0";
    unsigned char buffer[256];
    struct timeval t_old, t_new, tv;
    struct termios options;
    fd_set perm,set;

    if (argc>=2) strcpy(dev, argv[1]);
    if (argc==3) br = atoi(argv[2]);
    /* open socket to ttyS0 */
    if ((tty_sock=open(dev ,O_NDELAY | O_RDWR | O_NOCTTY))==-1) {
        perror("opening tty");
        return -1;
    }

    printf("tty_sock=%d\n", tty_sock);
    /* Get the current options for the port... */
    tcgetattr(tty_sock, &options);

    /* No parity (8N1) */
    options.c_iflag = IGNBRK;
    options.c_oflag = 0;
    options.c_lflag = 0;
    options.c_cflag = CS8 | CLOCAL | CREAD;

    switch (br) {
        case 9600 :
            /* Set the baud rates to 9600... */
            printf("Baud rate = 9600\n");
            cfsetispeed(&options, B9600);
            cfsetospeed(&options, B9600);
            break;

        case 19200:
            printf("Baud rate = 19200\n");
            cfsetispeed(&options, B19200);
            cfsetospeed(&options, B19200);
            break;

        case 38400:
            printf("Baud rate = 38400\n");
            cfsetispeed(&options, B38400);
            cfsetospeed(&options, B38400);
            break;

        default:
            printf("Bad baud rate %d\n", br);
            exit(0);
    }
    /*
    cfsetispeed(&options, B115200);
    cfsetospeed(&options, B115200);

    cfsetispeed(&options, B57600);
    cfsetospeed(&options, B57600);
    */

    /* Set the new options for the port... */
    tcsetattr(tty_sock, TCSANOW, &options);

    FD_ZERO(&perm);
    FD_SET(tty_sock, &perm);

    while (1) {
        tv.tv_sec=1;
        tv.tv_usec=0;
        set = perm;
        ret = select(FD_SETSIZE,&set,NULL,NULL,&tv);
        //printf("just returned from select with following value: %d\n", ret);
        if (ret < 0) {
            perror("select");
        }
        else if (ret > 0) {
            ret=read(tty_sock, buffer, 255);
            t_old=t_new;
            gettimeofday(&t_new, NULL);
            printf("tty=0x");
            for (i=0; i<ret; i++) printf("%02x ",buffer[i]);
            printf(" dt: %d\n", tv_diff(t_old, t_new));
        }
    }
    return 0;
}

